'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _datCp = require('./lib/dat-cp');

var _datCp2 = _interopRequireDefault(_datCp);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

exports.default = (() => {
  var _ref = _asyncToGenerator(function* (key, program) {
    const datCp = new _datCp2.default(program, { key, sparse: true });
    yield datCp.connect();

    if (!program.skipPrompt) {
      yield datCp.download(true);
    }

    if (program.dryRun || !program.skipPrompt && datCp.files === 0) {
      process.exit();
    }

    if (!program.skipPrompt) {
      const proceed = yield datCp.downloadPrompt();

      if (!proceed) {
        process.exit();
      }
    }

    datCp.resetCounts();
    yield datCp.download();

    process.exit();
  });

  function receive(_x, _x2) {
    return _ref.apply(this, arguments);
  }

  return receive;
})();